#!/usr/bin/python2.4
# -*- coding: utf-8 -*-
#getrss.py
#This file is part of getrss.
#getrss is a rss downloader and parser to be used by gprss in GP2X

#Copyright (C) 2006 Carlos Galisteo de Cabo <cgalisteo@k-rolus.net>

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import cPickle
from feeds import feeds
import sys,os
import posix
sys.path.insert(0, "./modules")
from urllib2 import Request, urlopen
import feedparser

dic_tit_arch={}

def get_url(url):
  req = Request(url)
  try:
      handle = urlopen(req)
  except IOError, e:
      if hasattr(e, 'reason'):
          print 'ERROR!!'
          print '\tReason: ', e.reason
	  raise "error"
      elif hasattr(e, 'code'):
          print 'ERROR!!'
          print '\tError code: ', e.code
	  raise "error"
  return handle.read()

def fixname(url):
  filename=''
  lname=url.split('/')[2:]
  for n in lname:
    if n != "":
      filename=filename+'_'+n
  filename= filename.replace('.','_').lstrip('_')+".xml"
  return filename

for url in feeds:
  print "Url detected:%s"%url
  print "\tDownloading...",
  sys.stdout.flush()
  filename=fixname(url)
  try:
    fh=open('./feeds/%s'%filename,'w')
  except IOError:
    print "ERROR!!"
    print "Please create a 'feeds' directory"
    sys.exit(0)

  try:
    fh.write(get_url(url))
  except:
    continue
  fh.close()
  print "Done"
  print "\tParsing...",
  sys.stdout.flush()
  ruta_o=os.path.join("feeds", filename)
  o = feedparser.parse(ruta_o)
  try:
    t_o=o.feed.title
  except:
    t_o="sin titulo"
  gp2xfile=os.path.join("feeds_gp2x", "%s.dic"%filename)
  dic_tit_arch[t_o]=ruta_o
  dic_noticias=feedparser.parse(dic_tit_arch[t_o])
  dic_tit_arch[t_o]=gp2xfile
  try:
    fichero = open(gp2xfile, 'w')
  except IOError:
    print "ERROR!!"
    print "Please create a 'feeds_gp2x' directory"
    sys.exit(0)
  cPickle.dump(dic_noticias, fichero)
  fichero.close()
  print "Done"

# Saving titles dic
fichero = open(os.path.join("feeds_gp2x", "titles.dic"), 'w')
cPickle.dump(dic_tit_arch, fichero)
fichero.close()

