#!/usr/bin/python2.4
# -*- coding: utf-8 -*-

#gprss.py
#This file is part of gprss.
#gprss is a free rss reader for GP2X

#Copyright (C) 2006 Carlos Galisteo de Cabo <cgalisteo@k-rolus.net>

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import pygame
import sys
import os
import cPickle
sys.path.insert(0, "./modules")
from txtprocess import *
import libmenu


def  main():
    ## Recuperar diccionario titulos
    fichero = open('feeds_gp2x/titles.dic', 'r')
    dic_tit_arch = cPickle.load(fichero)
    lst_titulos=dic_tit_arch.keys()
    fichero.close()
    selmenu=1
    while selmenu != -1:
      if selmenu==0:
        pass

      if selmenu==1: #Menu Origenes

        sel_origen = libmenu.SimpleMenu(libmenu.titleFont, "GP2X RSS READER", 1 , libmenu.itemFont, lst_titulos,selmenu)
        origen,selmenu = sel_origen.getInput()
        libmenu.prevsel=1
      elif selmenu==2:#menu titulares

        fichero = open(dic_tit_arch.values()[origen-1], 'r')
        dict_noticias = cPickle.load(fichero)
        fichero.close()
        noticias=[]
        for noticia in dict_noticias.entries:
          noticias.append(noticia.title)
        sel_noticia = libmenu.SimpleMenu(libmenu.titleFont, lst_titulos[origen-1].upper(), 1 ,libmenu.itemFont, noticias,selmenu)
        libmenu.prevsel=origen
        noticia,selmenu=sel_noticia.getInput()

      elif selmenu==3:#Lectura contenido
        try:
          contenido=limpia_html(dict_noticias.entries[noticia-1]['summary'])
        except KeyError:
          contenido="No summary available"
        contenido=format_text(contenido)
        libmenu.prevsel=noticia
        lee_noticia=libmenu.MuestraNoticia(libmenu.titleFont, lst_titulos[origen-1].upper(), 1 ,libmenu.itemFont,contenido,selmenu)
        selmenu=lee_noticia.procesa()

if __name__ == '__main__':
  pygame.init()
  num_joysticks = pygame.joystick.get_count()
  if num_joysticks > 0:
    stick = pygame.joystick.Joystick(0)
    stick.init()
  libmenu.screen = pygame.display.set_mode([320, 240], 0, 16)
  libmenu.background =pygame.Surface( libmenu.screen.get_size( ))
  libmenu.background.fill(( 240, 240, 240 ))
  icono=pygame.image.load("./img/rss.png").convert()
  libmenu.background.blit(icono,(15,5))
  pygame.mouse.set_visible(0)
  pygame.display.set_caption("GP2X RSS READER")
  libmenu.titleFont = pygame.font.Font(os.path.join("fonts", "Skizzed DSG.ttf"), 20)
  libmenu.itemFont = pygame.font.Font(os.path.join("fonts", "VeraMoBI.ttf"), 10)
  main()