

#This file is part of gprss.
#libmenu.py
#This file is part of gprss.
#gprss is a free rss reader for GP2X

#Copyright (C) 2006 Carlos Galisteo de Cabo <cgalisteo@k-rolus.net>

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.



import pygame
from pygame.locals import *
import sys
from gp2x import *

zoom=1
max_length=50
max_high=14

prevsel=1

lightColor = (255, 153, 57)
darkColor = (118, 118, 151)
class Menu:

  def __init__(self, titleFont, title):

    self.titleFont = titleFont
    self.title = title


class SimpleMenu(Menu):

  def __init__(self, titleFont, title, gap, itemFont, listItem,selmenu):

    Menu.__init__(self, titleFont, title)

    self.gap = gap
    self.itemFont = itemFont
    self.listItem = listItem
    self.selmenu = selmenu


    # Display the Title
    titleMenu = SimpleTitleOnlyMenu(self.titleFont, self.title)

    self.startY = titleMenu.startY

    # Which item is selected
    self.select=prevsel
    #prevsel=1

  def getInput(self):

    lineas_mostradas_inicio=0
    lineas_mostradas_fin=14
    self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
    while 1:

      # Get the event keys
      event= pygame.event.poll()
      if event.type == QUIT:
          sys.exit(0)
      #PC events
      elif event.type == KEYDOWN:
        if event.key == K_ESCAPE:
          sys.exit(0)
          return -1
        if event.key == K_q:
          sys.exit(0)
          return -1
        if event.key == K_w:
          if self.selmenu!=1:
            self.selmenu-=1
            return self.select,self.selmenu
        if event.key == K_UP:
          #print "sel:%d - de  %d a %d"%(self.select,lineas_mostradas_inicio,lineas_mostradas_fin)
          if self.select-1 != lineas_mostradas_inicio:
            if (self.select-1)+lineas_mostradas_inicio == lineas_mostradas_inicio:
              if (lineas_mostradas_inicio-max_high)<0:
                lineas_mostradas_inicio=0
                lineas_mostradas_fin=max_high
                self.select=max_high
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
              else:
                lineas_mostradas_inicio-=max_high
                lineas_mostradas_fin-=max_high
                self.select=max_high
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
                self.select-=1
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)

        if event.key == K_DOWN:
          #print "sel:%d - de  %d a %d"%(self.select,lineas_mostradas_inicio,lineas_mostradas_fin)

          if self.select != len(self.listItem):
            if self.select+lineas_mostradas_inicio == lineas_mostradas_fin:
              if (lineas_mostradas_fin+max_high)<len(self.listItem):
                lineas_mostradas_inicio+=max_high
                lineas_mostradas_fin+=max_high
                self.select=1
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
              else:
                i=max_high
                while ((lineas_mostradas_fin+i)>len(self.listItem)):
                  i-=1
                lineas_mostradas_inicio+=i
                lineas_mostradas_fin+=i
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              self.select += 1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
          else:
              pass
        if event.key == K_RETURN:
          self.selmenu+=1
          return (self.select+lineas_mostradas_inicio,self.selmenu)
        if event.key == K_PAGEDOWN:
          if lineas_mostradas_fin < len(self.listItem):
            if (lineas_mostradas_fin+max_high)<len(self.listItem):
              lineas_mostradas_inicio+=max_high
              lineas_mostradas_fin+=max_high
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              i=max_high
              while ((lineas_mostradas_fin+i)>len(self.listItem)):
                i-=1
              lineas_mostradas_inicio+=i
              lineas_mostradas_fin+=i
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.key == K_PAGEUP:
          if lineas_mostradas_inicio !=0:
            if (lineas_mostradas_inicio-max_high)<0:
              lineas_mostradas_inicio=0
              lineas_mostradas_fin=max_high
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              lineas_mostradas_inicio-=max_high
              lineas_mostradas_fin-=max_high
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
	#GP2X events
      elif event.type == JOYBUTTONDOWN:
        if event.button == BUTTON_START:
          sys.exit(0)
          return -1
        if (event.button == BUTTON_SELECT) or (event.button == BUTTON_Y):
          self.selmenu=1
          return (self.select,self.selmenu)
        if (event.button == BUTTON_LEFT) or (event.button == BUTTON_X):
          if self.selmenu!=1:
            self.selmenu-=1
            return self.select,self.selmenu
        if event.button == BUTTON_UP:
          if self.select-1 != lineas_mostradas_inicio:
            if (self.select-1)+lineas_mostradas_inicio == lineas_mostradas_inicio:
              if (lineas_mostradas_inicio-max_high)<0:
                lineas_mostradas_inicio=0
                lineas_mostradas_fin=max_high
                self.select=max_high
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
              else:
                lineas_mostradas_inicio-=max_high
                lineas_mostradas_fin-=max_high
                self.select=max_high
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
                self.select-=1
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)

        if event.button == BUTTON_DOWN:
          if self.select != len(self.listItem):
            if self.select+lineas_mostradas_inicio == lineas_mostradas_fin:
              if (lineas_mostradas_fin+max_high)<len(self.listItem):
                lineas_mostradas_inicio+=max_high
                lineas_mostradas_fin+=max_high
                self.select=1
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
              else:
                i=max_high
                while ((lineas_mostradas_fin+i)>len(self.listItem)):
                  i-=1
                lineas_mostradas_inicio+=i
                lineas_mostradas_fin+=i
                self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              self.select += 1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
          else:
              pass
        if (event.button == BUTTON_B) or (event.button == BUTTON_CLICK):
          self.selmenu+=1
          return (self.select,self.selmenu)
        if event.button == BUTTON_R:
          if lineas_mostradas_fin < len(self.listItem):
            if (lineas_mostradas_fin+max_high)<len(self.listItem):
              lineas_mostradas_inicio+=max_high
              lineas_mostradas_fin+=max_high
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              i=max_high
              while ((lineas_mostradas_fin+i)>len(self.listItem)):
                i-=1
              lineas_mostradas_inicio+=i
              lineas_mostradas_fin+=i
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.button == BUTTON_L:
          if lineas_mostradas_inicio !=0:
            if (lineas_mostradas_inicio-max_high)<0:
              lineas_mostradas_inicio=0
              lineas_mostradas_fin=max_high
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              lineas_mostradas_inicio-=max_high
              lineas_mostradas_fin-=max_high
              self.select=1
              self.refresh(lineas_mostradas_inicio,lineas_mostradas_fin)

  def refresh(self,lineas_mostradas_inicio,lineas_mostradas_fin):

    y = self.startY
    i = 1
    # Print the menu items
    for item in self.listItem[lineas_mostradas_inicio:lineas_mostradas_fin]:
      #strip long tittles
      if item.__len__()>max_length:
        item=item[:max_length-3]+"..."

      if i == self.select:
        text = self.itemFont.render(item, 1, lightColor)
      else:
        text = self.itemFont.render(item, 1, darkColor)

      textRect = text.get_rect()
      textRect.centerx = screen.get_rect().centerx
      textRect.y = y
      deleteRect = (0, textRect.y, 1024*zoom, textRect.height)
      screen.blit(background, deleteRect, deleteRect)
      screen.blit(text, textRect)
      y = y + textRect.height + self.gap
      i = i + 1

    pygame.display.flip()

class SimpleTitleOnlyMenu(Menu):
  '''Menu only with a title'''

  def __init__(self, titleFont, title):

    Menu.__init__(self, titleFont, title)

    # Put the background
    screen.blit(background, (0, 0))

    y = 10

    # Print the title

    if self.title.__len__()>18:
      self.title=self.title[:17]+"..."

    textTitle = self.titleFont.render(self.title, 1, lightColor)
    textRectTitle = textTitle.get_rect()
    textRectTitle.centerx = screen.get_rect().centerx+20
    textRectTitle.y = y
    y = y + textRectTitle.height/2
    text = self.titleFont.render("."*(len(self.title)*2), 1, lightColor)
    textRect = text.get_rect()
    textRect.centerx = screen.get_rect().centerx+20
    textRect.y = y
    deleteRect = (0, textRect.y, 1024*zoom, textRect.height)
    deleteRectTitle = (0, textRectTitle.y, 1024*zoom, textRectTitle.height)
    screen.blit(background, deleteRectTitle, deleteRectTitle)
    screen.blit(background, deleteRect, deleteRect)
    screen.blit(textTitle, textRectTitle)
    screen.blit(text, textRect)
    y = y + textRect.height

    self.startY = y

    pygame.display.flip()

class MuestraNoticia(Menu):

  def __init__(self, titleFont, title, gap, itemFont, listItem,selmenu):

    Menu.__init__(self, titleFont, title)

    self.gap = gap
    self.itemFont = itemFont
    self.listItem = listItem
    if not self.listItem:self.listItem=["","No summary available"]
    self.selmenu = selmenu

    # Display the Title
    titleMenu = SimpleTitleOnlyMenu(self.titleFont, self.title)
    self.startY = titleMenu.startY

  def rellena(self,lineas_mostradas_inicio,lineas_mostradas_fin):
    y = self.startY
    i = 1

    for item in self.listItem[lineas_mostradas_inicio:lineas_mostradas_fin]:
      text = self.itemFont.render(item, 1, darkColor)
      textRect = text.get_rect()
      textRect.centerx = textRect.centerx + 5
      textRect.y = y
      deleteRect = (0, textRect.y, 1024*zoom, textRect.height)
      screen.blit(background, deleteRect, deleteRect)
      screen.blit(text, textRect)
      y = y + textRect.height + self.gap
      i = i + 1
    pygame.display.flip()

  def procesa(self):
    lineas_mostradas_inicio=0
    lineas_mostradas_fin=14
    self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
    while 1:
    # Get the event keys
      event= pygame.event.poll()
      if event.type == QUIT:
        sys.exit(0)
      elif event.type == KEYDOWN:
        if event.key == K_ESCAPE:
          sys.exit(0)
          return -1
        if event.key == K_q:
          sys.exit(0)
          return -1
        if event.key == K_w:
          self.selmenu-=1
          return self.selmenu
        if event.key == K_DOWN:
          if lineas_mostradas_fin < len(self.listItem):
            lineas_mostradas_inicio+=1
            lineas_mostradas_fin+=1
            self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.key == K_UP:
          if lineas_mostradas_inicio != 0:
            lineas_mostradas_inicio-=1
            lineas_mostradas_fin-=1
            self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.key == K_PAGEDOWN:
          if lineas_mostradas_fin < len(self.listItem):
            if (lineas_mostradas_fin+max_high)<len(self.listItem):
              lineas_mostradas_inicio+=max_high
              lineas_mostradas_fin+=max_high
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              i=max_high
              while ((lineas_mostradas_fin+i)>len(self.listItem)):
                i-=1
              lineas_mostradas_inicio+=i
              lineas_mostradas_fin+=i
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.key == K_PAGEUP:
          if lineas_mostradas_inicio !=0:
            if (lineas_mostradas_inicio-max_high)<0:
              lineas_mostradas_inicio=0
              lineas_mostradas_fin=max_high
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              lineas_mostradas_inicio-=max_high
              lineas_mostradas_fin-=max_high
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
      #GP2X events
      elif event.type == JOYBUTTONDOWN:
        if event.button == BUTTON_START:
          sys.exit(0)
          return -1
        if (event.button == BUTTON_LEFT) or (event.button == BUTTON_X):
          self.selmenu-=1
          return self.selmenu
        if (event.button == BUTTON_SELECT) or (event.button == BUTTON_Y):
          self.selmenu=1
          return self.selmenu
        if event.button == BUTTON_DOWN:
          if lineas_mostradas_fin < len(self.listItem):
            lineas_mostradas_inicio+=1
            lineas_mostradas_fin+=1
            self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.button == BUTTON_UP:
          if lineas_mostradas_inicio != 0:
            lineas_mostradas_inicio-=1
            lineas_mostradas_fin-=1
            self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.button == BUTTON_R:
          if lineas_mostradas_fin < len(self.listItem):
            if (lineas_mostradas_fin+max_high)<len(self.listItem):
              lineas_mostradas_inicio+=max_high
              lineas_mostradas_fin+=max_high
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              i=max_high
              while ((lineas_mostradas_fin+i)>len(self.listItem)):
                i-=1
              lineas_mostradas_inicio+=i
              lineas_mostradas_fin+=i
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
        if event.button == BUTTON_L:
          if lineas_mostradas_inicio !=0:
            if (lineas_mostradas_inicio-max_high)<0:
              lineas_mostradas_inicio=0
              lineas_mostradas_fin=max_high
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)
            else:
              lineas_mostradas_inicio-=max_high
              lineas_mostradas_fin-=max_high
              self.rellena(lineas_mostradas_inicio,lineas_mostradas_fin)


